// ----------------------------------------------------------------------------
// InputX.java
// Character-oriented input from standard input stream.
//
// Author:  Wolfgang Schreiner <Wolfgang.Schreiner@risc.jku.at>
// Created: December 30, 2018
// ----------------------------------------------------------------------------

package kwm;

public class InputX 
{
  // last line read from input stream (if null, new line is to be read) 
  // position of next character to be delivered
  private static String line = null;
  private static int pos = -1;
  
  // --------------------------------------------------------------------------
  // c = readChar()
  // Reads next character "c" from standard input.
  //
  // Input condition:
  //   "Input.hasEnded()" is false.
  // Output condition:
  //   if "Input.isOkay()", then "c" is a character read from standard input.
  //   "c" may also be a "newline" character ('\n').
  // --------------------------------------------------------------------------
  public static char readChar()
  {
    if (line == null)
    {
      String line0 = Input.readString();
      if (!Input.isOkay()) return 0;
      line = line0;
      pos = 0;
    }
    if (pos == line.length())
    {
      line = null;
      return '\n';
    }
    char result = line.charAt(pos);
    pos = pos+1;
    return result;
  }
}
